#include "taginfo.h"
#include <stdio.h>
#include <iostream>
#include <fstream>

#define TESTNAME "xyz 1 23"

using namespace TagInfo;

int main( void ) {
    Info * info;
    std::string val = TESTDIR "samples/sample.m4a";
    //std::cout << std::endl << "val: " << val << std::endl;
    
    std::string target("/tmp/out_01.m4a");
    
    std::ifstream  src(val.c_str());
    std::ofstream  dst(target.c_str());
    dst << src.rdbuf();
    
    info = Info::create_tag_info(target);
    if( info ) {
        info->set_title(TESTNAME);
        info->set_album_artist("äöé");
        info->set_is_compilation(true);
        info->set_comments("Cömmmééèntß");
        info->set_year(1978);
        info->write();
    }
    delete info;
    info = NULL;
    
    info = Info::create_tag_info(target);
    if( info ) {
        if( info->read() ) {
            if(info->get_title() == TESTNAME &&
               info->get_album_artist() == "äöé" &&
               info->get_year() == 1978 &&
               info->get_comments() == "Cömmmééèntß" &&
               info->get_is_compilation()) {
                delete info;
                if(remove(target.c_str()) != 0 )
                    return EXIT_FAILURE;
                return EXIT_SUCCESS;
            }
        }
        delete info;
        if(remove(target.c_str()) != 0 )
            return EXIT_FAILURE;
        return EXIT_FAILURE;
    }
    else {
        delete info;
        if(remove(target.c_str()) != 0 )
            return EXIT_FAILURE;
        return EXIT_FAILURE;
    }
}
