#include "taginfo.h"
#include <stdio.h>
#include <iostream>
#include <fstream>

#define TESTNAME "xyz 1 23"

using namespace TagInfo;


bool check_list_equal(const StringList &list, const StringList &second) {
    //std::cout <<  "first : " << list.toString()   << std::endl;
    //std::cout <<  "second: " << second.toString() << std::endl;
    return(list.toString("") == second.toString(""));
}

int main( void ) {
    Info * info;
    std::string val = TESTDIR "samples/sample.ogg";
    //std::cout << std::endl << "val: " << val << std::endl;
    
    std::string target("/tmp/out_01.ogg");
    
    std::ifstream  src(val.c_str());
    std::ofstream  dst(target.c_str());
    dst << src.rdbuf();
    
    info = Info::create_tag_info(target);
    
    StringList labels = StringList();
    labels.append("user label1 äöüé");
    labels.append("user label1 äiiüé");
    if( info ) {
        info->set_title(TESTNAME);
        info->set_album_artist("äöé");
        info->set_is_compilation(true);
        info->set_track_labels_list(labels);
        info->set_comments("Cömmmééèntß");
        info->set_rating(2);
        info->set_playcount(86);
        info->set_year(1978);
        info->write();
    }
    delete info;
    info = NULL;
    
    info = Info::create_tag_info(target);
    if( info ) {
        if( info->read() ) {
            if(info->get_title() == TESTNAME &&
               info->get_album_artist() == "äöé" &&
               info->get_year() == 1978 &&
               info->get_rating() == 2 &&
               info->get_playcount() == 86 &&
               info->get_comments() == "Cömmmééèntß" &&
               info->get_is_compilation() == true &&
               check_list_equal(info->get_track_labels_list(), labels) ) {
                delete info;
                if(remove(target.c_str()) != 0 )
                    return EXIT_FAILURE;
                return EXIT_SUCCESS;
            }
        }
        delete info;
        if(remove(target.c_str()) != 0 )
            return EXIT_FAILURE;
        return EXIT_FAILURE;
    }
    else {
        delete info;
        if(remove(target.c_str()) != 0 )
            return EXIT_FAILURE;
        return EXIT_FAILURE;
    }
}
